package client;

import java.awt.*;
import java.awt.event.*;
import message.*;
import java.rmi.*;
import java.rmi.server.*;


public class Client extends Frame implements MessageReceiver,ActionListener //, WindowListener 
{
    TextField tf,tf2;
    TextArea ta;
    static String name;
    static MessageServer server;
    
    
    
    public Client() throws RemoteException 
    {
           setTitle(name);
           setLayout(new BorderLayout());
           tf = new TextField(30);
           tf.addActionListener(this);
           add("South",tf); 
	   	
           ta = new TextArea(20,20);
	   
           add("North",ta);
           
           addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent we){
        System.exit(0);
      }
    });
           UnicastRemoteObject.exportObject(this);
           // accept remote calls!
    }

   
    
    public void actionPerformed(ActionEvent ae) 
    {
        try 
        {
		//System.out.println("Sending");            
		server.send(name,tf.getText());

        }
        catch(Exception e) 
        {
        	System.out.println("Exception2: "+e);
        }
    }
    
    public void print(String s) 
    { 
    	ta.append(s+"\n");
	
	//System.out.println("Recd " +s);
	tf.setText("");
    }
    
    public static void main(String args[]) 
    {
    	if(args.length < 1) 
        {
    		System.out.println("USAGE: java client.Client NAME");
    		System.exit(-1); 
        }
    	name = args[0];
    	System.setSecurityManager(new RMISecurityManager());
    	try 
    	{
    		Client cf = new Client(); 
    		cf.pack();
    		cf.show();
    		
    		server =(MessageServer)Naming.lookup(MessageServer.SERVER_NAME);
    		
    		int s = server.register(args[0],cf);
    		if(s == MessageServer.FAILURE)
    			throw new Exception("Could not Connect to SERVER");
        } 
    	catch(Exception e) 
    	{
    		System.out.println("Exception3: "+e);
    		System.exit(-1);
    	}

    }
}


