package server;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;
import message.*;


public class Server extends UnicastRemoteObject implements MessageServer 
{
    static Hashtable receivers = new Hashtable(5);
    public Server() throws RemoteException 
    {
          super();
    }
    
    public void send(String name, String s) throws RemoteException 
    {
          for(Enumeration e = receivers.elements(); e.hasMoreElements(); ) 
          {
                MessageReceiver m = (MessageReceiver)e.nextElement();
                m.print(name + ": " + s);
		//System.out.println("Server printing");
          } // End For
    }// End send
    
    public int register( String name, MessageReceiver m) 
    {
        int retval = MessageServer.FAILURE;
        
        if((name != null) && (m != null)) 
        {
            if(receivers.get(name) == null) 
            {
                receivers.put(name,m);
                System.out.println("Added " + name);
                retval = MessageServer.SUCCESS;
            }
            else 
            {
                System.out.println("Client not added because " + name + " already exists on Server"); 
            }
         }
         return retval;
    }
    
    public static void main(String []args) 
    {
        System.setSecurityManager(new RMISecurityManager());
        
        try 
        { 
        	MessageServer server = new Server();
            // Bootstrap PRIVATE registry!
            Registry reg = LocateRegistry.createRegistry(Registry.REGISTRY_PORT);            
            reg.rebind(MessageServer.SERVER_NAME,server);
            
            System.out.println("Server bound and started");
        } 
        catch(Exception e) 
        {
        	System.out.println("Exception: " + e);
        } 
    }

    
}
